
stages:
- build
- test
- train
- publish
- notify

variables:
  SECURE_LOG_LEVEL: debug

workflow:
  rules:
  - if: "$CI_MERGE_REQUEST_IID"
  - if: "$CI_COMMIT_TAG"
  - if: "$CI_COMMIT_BRANCH"

gemnasium-python-dependency_scanning:
  image:
    name: $CI_TEMPLATE_REGISTRY_HOST/security-products/gemnasium-python:4-python-3.10
  
include:
#  - template: 'Workflows/MergeRequest-Pipelines.gitlab-ci.yml'
  - template: Security/SAST-IaC.gitlab-ci.yml
  - template: Security/Secret-Detection.gitlab-ci.yml
  - template: Jobs/Dependency-Scanning.gitlab-ci.yml
#  - template: Jobs/Container-Scanning.gitlab-ci.yml
  - template: Jobs/SAST.gitlab-ci.yml

train-candidate:
  stage: train
  image: python:3.10.13-bullseye
#  tags:
#  - saas-linux-medium-amd64-gpu-standard
  script:
  - pip install -r requirements.txt
  - ipython kernel install --name "python3" --user
  - papermill notebooks/train_candidates.ipynb -
  rules:
  - if: $CI_PIPELINE_SOURCE == "merge_request_event"
    when: manual
  - if: $CI_COMMIT_BRANCH
    when: manual
  artifacts:
    paths:
    - ./model_metrics.md

publish-metrics-comment:
  stage: notify
  image:
    name: gitlab/glab
    entrypoint: [ "" ]
  script:
  - glab auth login -t $REPO_TOKEN
  - glab -R "$CI_PROJECT_URL" mr note $CI_MERGE_REQUEST_IID -m "$(cat model_metrics.md)"
  rules:
  - if: $CI_PIPELINE_SOURCE == "merge_request_event"
    when: on_success
  - if: $CI_COMMIT_BRANCH
    when: on_success
  needs:
  - train-candidate

train-model-version:
  stage: publish
  image: python:3.10.13-bullseye
#  tags:
#  - saas-linux-medium-amd64-gpu-standard
  script:
  - pip install -r requirements.txt
  - ipython kernel install --name "python3" --user
  - papermill -p model_version $CI_COMMIT_TAG -p source_candidate_id $CI_COMMIT_TAG_MESSAGE notebooks/train_model_version.ipynb -
  rules:
    - if: $CI_COMMIT_TAG
  when: manual

